/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

/*
 * Created on Feb 7, 2005
 *
 */
package com.sunlabs.archsim.tests.splitter;

/**
 * @author ib27688
 *
 * Used to store the names for actions, terminals, and states
 */
public class SplitterGlobal {

	/** never make an instance of this class */
	private SplitterGlobal() {}
	
	public static final String DATA_IN_TERMINAL_NAME= "dataInTerminal";
	public static final String SPLIT_BITS_OUT_TERMINAL_NAME= "splitBitsOutTerminal";
	public static final String ACK_SPLIT_BITS_TERMINAL_NAME= "ackSplitBitsOutTerminal";
	public static final String REMAINDER_OUT_TERMINAL_NAME= "remainderOutTerminal";

	public static final String SPLIT_ACTION_NAME= "splitAction";
	
	public static final String DATA_IN_STATE_NAME= "dataInState";
	public static final String ACK_DATA_IN_STATE_NAME= "ackDataInState";
	public static final String DATA_OUT_STATE_NAME= "dataOutState";
	public static final String ACK_DATA_OUT_STATE_NAME= "ackDataOutState";
	
	public static final String REMAINDER_OUT_STATE_NAME= "remainderOutState";
	
	public static final String REMAINDER_STATE_NAME= "remainderState";
	
	public static boolean sourceDisplayGenerated= true;
	public static boolean sinkDisplayReceived= true;
	
	public static final int DATAPATH_WIDTH= 64;
	public static final int bitsToSplit= 12;
	public static int cycle= 5;

} // names
