package edu.berkeley.sbp;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.lang.ref.*;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.util.*;

/** <font color=purple>a stream of <tt>Token</tt>s to be parsed</font> */
public interface Input<Token> {

    /** returns the token just beyond the current location and advances beyond it */
    public Token           next() throws IOException;

    /** returns the location the input stream is currently at */
    public Location<Token> getLocation();

    /** <font color=purple>a location (position) in the input stream -- <i>between tokens</i></font> */
    public static interface Location<Token> extends Comparable<Location> {

        /** return the region between this location and <tt>loc</tt> */
        public Region<Token> createRegion(Location<Token> loc);

        public String toString();
    }

    /** <font color=purple>a contiguous set of <tt>Location</tt>s</font> */
    public static interface Region<Token> /* implements Topology<Location<Tok>> */ {
    }

}


